Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.198
diff -u -r1.198 pbx.c
--- pbx.c	21 Jan 2005 07:06:24 -0000	1.198
+++ pbx.c	22 Jan 2005 01:31:08 -0000
@@ -5023,6 +5023,30 @@
 	return res;
 }
 
+void pbx_builtin_dupvar_helper(struct ast_channel *chan, struct ast_channel *new_chan)
+{
+	struct ast_var_t *new_variable, *variable, *fresh_variable;
+	struct varshead *headp, *new_headp;
+	
+	if (chan)
+		headp = &chan->varshead;
+	else
+		headp = &globals;
+
+	AST_LIST_TRAVERSE(headp,variable,entries) {
+		new_headp=&new_chan->varshead;
+		AST_LIST_TRAVERSE (new_headp, new_variable, entries) {
+			if (strcasecmp(ast_var_name(new_variable), ast_var_name(variable)) == 0) {
+				/* there is already such a variable */
+				continue;
+			}
+			fresh_variable = ast_var_assign(ast_var_name(variable), ast_var_value(variable));
+			AST_LIST_INSERT_HEAD(new_headp, fresh_variable, entries);
+		}
+	}
+
+
+}
 
 int pbx_builtin_serialize_variables(struct ast_channel *chan, char *buf, size_t size) 
 {
Index: include/asterisk/pbx.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/pbx.h,v
retrieving revision 1.39
diff -u -r1.39 pbx.h
--- include/asterisk/pbx.h	15 Jan 2005 23:48:12 -0000	1.39
+++ include/asterisk/pbx.h	22 Jan 2005 01:31:08 -0000
@@ -568,6 +568,7 @@
 int pbx_builtin_serialize_variables(struct ast_channel *chan, char *buf, size_t size);
 extern char *pbx_builtin_getvar_helper(struct ast_channel *chan, char *name);
 extern void pbx_builtin_setvar_helper(struct ast_channel *chan, char *name, char *value);
+extern void pbx_builtin_dupvar_helper(struct ast_channel *chan, struct ast_channel *newchan);
 extern void pbx_retrieve_variable(struct ast_channel *c, const char *var, char **ret, char *workspace, int workspacelen, struct varshead *headp);
 extern void pbx_builtin_clear_globals(void);
 extern int pbx_builtin_setvar(struct ast_channel *chan, void *data);
